/*Behold... baby's second LUA spaghetti code! Fear its overcomplicated recipe!
What's that? Where's the first? Check back in 2025, maybe
~~~~~
this entire lua script is for the jetpack/scuba gear, unlocked when the player
manages to get all 7 chaos emeralds, and all of crash's deaths and how he 
interacts with other players*/

local function JetpackFumes(player)
	if player.mo.eflags & MFE_UNDERWATER or player.mo.eflags & MFE_GOOWATER
		P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_MEDIUMBUBBLE)
	else
		P_SpawnThokMobj(player)
	end
	P_SpawnSkidDust(player, 25 * FRACUNIT)
end
local EquipFrames = {
	[S_PLAY_SUPER_TRANS1] = true,
	[S_PLAY_SUPER_TRANS2] = true,
	[S_PLAY_SUPER_TRANS3] = true,
	[S_PLAY_SUPER_TRANS4] = true,
	[S_PLAY_SUPER_TRANS5] = true,
	[S_PLAY_SUPER_TRANS6] = true
}
local function ScubaJetpack(player)
	if not CrashSkinCheck(player)
		return
	end
	
	if All7Emeralds(player.powers[pw_emeralds]) or All7Emeralds(emeralds)
		/*this allows the player to equip/unequip the jetpack if they press
		custom 2 and have any amount of rings at all while on the ground*/
		if player.jetpackmode == nil
			player.jetpackmode = false
		end
		if player.pressequip == nil
			player.pressequip = false
		end
		if input.gameControlDown(GC_CUSTOM2) and player.rings > 0 and
				P_IsObjectOnGround(player.mo)
			if not player.pressequip
				if player.jetpackmode
					player.mo.eflags = $ & ~MFE_FORCESUPER
					player.jetpackmode = false
				else
					player.mo.state = S_PLAY_SUPER_TRANS1
					player.mo.eflags = $ | MFE_FORCESUPER
					player.jetpackmode = true
				end
				player.pressequip = true
			end
		else
			player.pressequip = false
		end
	end
	if player.mo.eflags & MFE_FORCESUPER and not EquipFrames[player.mo.state]
		//this allows the player to do the spin while in jetpack mode
		CrashTornadoSpin(player)
		//this handles the different sprites displayed
		if not P_IsObjectOnGround(player.mo)
			local wiggle = 1 * FRACUNIT / 2
			if (player.mo.momx <= wiggle and player.mo.momx >= wiggle * -1) and 
					(player.mo.momy <= wiggle and player.mo.momy >= wiggle * -1)
				if not (player.mo.state == S_PLAY_FLOAT or player.mo.state ==
						S_PLAY_SWIM or player.mo.state == S_PLAY_CLING)
					player.mo.state = S_PLAY_FLOAT
				end
			else
				if not (player.mo.state == S_PLAY_RUN or player.mo.state ==
						S_PLAY_SWIM or player.mo.state == S_PLAY_CLING)
					player.mo.state = S_PLAY_RUN
				end
			end
		end
		//this is the ring drain mechanic
		if player.draintimer == nil
			player.draintimer = 1 * TICRATE
		end
		if player.draintimer <= 0
			player.rings = $ - 1
			player.draintimer = 1 * TICRATE
		end
		//this allows the player to breathe underwater and switch to scuba gear
		if player.mo.eflags & MFE_UNDERWATER or player.mo.eflags & MFE_GOOWATER
			player.powers[pw_underwater] = 30 * TICRATE
			if not (player.mo.state == S_PLAY_SWIM or player.mo.state == 
					S_PLAY_CLING)
				player.mo.state = S_PLAY_SWIM
			end
			player.draintimer = $ - 1
		elseif player.mo.state == S_PLAY_SWIM
			player.mo.state = S_PLAY_FLOAT
		end
		//this handles the jetpack/scuba ascent/descent
		if input.gameControlDown(GC_JUMP) and player.pflags & PF_JUMPED and not
				(player.pflags & PF_STARTJUMP)
			JetpackFumes(player)
			CrashJumpManager(player.mo, 7 * FRACUNIT)
			player.draintimer = $ - 3
		elseif input.gameControlDown(GC_SPIN) and not P_IsObjectOnGround(player.mo)
			JetpackFumes(player)
			if (player.mo.eflags & MFE_VERTICALFLIP and player.mo.momz > 0) or
					(not (player.mo.eflags & MFE_VERTICALFLIP) and 
					player.mo.momz < 0)
				CrashJumpManager(player.mo, -2 * FRACUNIT)
			end
			player.draintimer = $ - 1
		end
		//this forces the player out of jetpack mode if they ran out of rings
		if player.rings <= 0
			player.mo.eflags = $ & ~MFE_FORCESUPER
			player.mo.state = S_PLAY_FALL
			player.jetpackmode = false
		end
	end
end
addHook("PlayerThink", ScubaJetpack)

/*this makes it so the player can't grab air bubbles while in scuba gear, since
they don't need it*/
local function NoBubbles(special, toucher)
	if toucher.skin == "bandicoot" and toucher.eflags & MFE_FORCESUPER
		return true
	end
end
addHook("TouchSpecial", NoBubbles, MT_EXTRALARGEBUBBLE)

//this knocks other players back if the crash player spins into them
local function TornadoKnockback(thing, tmthing)
	if tmthing.skin == "bandicoot" and tmthing.state == S_PLAY_CLING
		if tmthing.z >= thing.z - thing.height and tmthing.z <= thing.z + 
				thing.height
			if thing.knockcooldown == nil
				thing.knockcooldown = 0
			end
			if thing.knockcooldown <= 0
				P_DoPlayerPain(thing.player)
				thing.player.powers[pw_flashing] = 0
				S_StartSound(thing, sfx_cshpew)
				thing.knockcooldown = 3 * TICRATE
			else
				thing.knockcooldown = $ - 1
				return
			end
		end
	end
end
addHook("MobjCollide", TornadoKnockback, MT_PLAYER)

//this is where the magic happens, all the death animations are right here
local function DeathAnimTrigger(target, inflictor, source, damagetype)
	if target.skin != "bandicoot"
		return
	end
	
	target.player.playerstate = PST_DEAD
	target.momx = 0
	target.momy = 0
	local clone = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_ARIDDUST)
	clone.skin = target.skin
	clone.color = target.color
	clone.deadAI = true
	clone.deathtype = damagetype
	if inflictor != nil
		if inflictor.type == MT_TNTBARREL and damagetype != DMG_NUKE
			clone.deathtype = DMG_NUKE
		end
	end
	clone.deadsound = false
	clone.animtimer = 5 * TICRATE
	clone.flags = $ & ~MF_NOGRAVITY
	clone.flags = $ | MF_NOCLIPHEIGHT
	return true
end
addHook("MobjDeath", DeathAnimTrigger, MT_PLAYER)

local function OvercookedMarsupial(mo)
	if not mo.deadsound
		S_StartSound(mo, sfx_ashcsh)
		mo.colorized = true
		mo.color = SKINCOLOR_BLACK
		mo.deadsound = true
	end
	mo.momz = 0
	if not (mo.state == S_PLAY_DEAD)
		mo.state = S_PLAY_DEAD
	end
end
local function RedneckXRay(mo)
	if not mo.deadsound
		S_StartSound(mo, sfx_cshxry)
		mo.deadsound = true
	end
	mo.momz = 0
	if not (mo.state == S_PLAY_DEAD)
		mo.state = S_PLAY_DEAD
	end
	if mo.animtimer % 2 == 0
		mo.colorized = true
	else
		mo.colorized = false
	end
end
local function OrangePOPsicle(mo)
	if not mo.deadsound
		print("insert popped bandicoot here")
		mo.deadsound = true
	end
	mo.momz = 0
end
local function CrashTheJigsaw(mo)
	if not mo.deadsound
		print("insert pieces of bandicoot here")
		mo.deadsound = true
	end
	mo.momz = 0
end
local function AngelDeath(mo)
	if not mo.deadsound
		S_StartSound(mo, sfx_cshdth)
		S_StartSound(mo, sfx_cshngl)
		mo.deadsound = true
	end
	CrashJumpManager(mo, 6 * FRACUNIT)
	if not (mo.state == S_PLAY_DEAD)
		mo.state = S_PLAY_DEAD
	end
end
local function Waterlogged(mo)
	if not mo.deadsound
		S_StartSound(mo, sfx_crdrwn)
		mo.deadsound = true
	end
	CrashJumpManager(mo, -2 * FRACUNIT)
	if not (mo.state == S_PLAY_DRWN)
		mo.state = S_PLAY_DRWN
	end
end
local function MostTameSpaceDeath(mo)
	if not mo.deadsound
		print("insert space bandicoot here")
		mo.deadsound = true
	end
	mo.momz = 0
end
local function NoFlyingType(mo)
	if not mo.deadsound
		S_StartSound(mo, sfx_cshdth)
		S_StartSound(mo, sfx_cshfal)
		mo.deadsound = true
	end
	CrashJumpManager(mo, -30 * FRACUNIT)
	if not (mo.state == S_PLAY_FALL)
		mo.state = S_PLAY_FALL
	end
end
local function FlatBandicoot(mo)
	if not mo.deadsound
		S_StartSound(mo, sfx_cshdth)
		mo.deadsound = true
	end
	mo.momz = 0
	if not (mo.state == S_PLAY_DEAD)
		mo.state = S_PLAY_DEAD
		mo.frame = $ | FF_FLOORSPRITE
	end
end
local DeathTypes = {
	[DMG_FIRE] = OvercookedMarsupial,
	[DMG_ELECTRIC] = RedneckXRay,
	[DMG_SPIKE] = OrangePOPsicle,
	[DMG_NUKE] = CrashTheJigsaw,
	[DMG_INSTAKILL] = AngelDeath,
	[DMG_DROWNED] = Waterlogged,
	[DMG_SPACEDROWN] = MostTameSpaceDeath,
	[DMG_DEATHPIT] = NoFlyingType,
	[DMG_CRUSHED] = FlatBandicoot
}
local ValidDeathTypes = {
	[DMG_FIRE] = true,
	[DMG_ELECTRIC] = true,
	[DMG_SPIKE] = true,
	[DMG_NUKE] = true,
	[DMG_INSTAKILL] = true,
	[DMG_DROWNED] = true,
	[DMG_SPACEDROWN] = true,
	[DMG_DEATHPIT] = true,
	[DMG_CRUSHED] = true
}
local function DeathAnimations(mo)
	if mo.deadAI
		if mo.animtimer <= 0
			P_RemoveMobj(mo)
		else
			if ValidDeathTypes[mo.deathtype]
				DeathTypes[mo.deathtype](mo)
			else
				AngelDeath(mo)
			end
			mo.animtimer = $ - 1
		end
	end
end
addHook("MobjThinker", DeathAnimations, MT_ARIDDUST)