/*Behold... baby's second LUA spaghetti code! Fear its overcomplicated recipe!
What's that? Where's the first? Check back in 2025, maybe
~~~~~
this entire lua script is for crash's main abilities and some minor stuff*/

//a global function to make skinchecking easier
rawset(_G, "CrashSkinCheck", function(player)
	if player.mo == nil
		return false
	end
	if player.mo.skin != "bandicoot"
		return false
	end
	return true
end)

/*this function just makes different jumps easier to manage since they all share
the same setup*/
rawset(_G, "CrashJumpManager", function(mo, height)
	if mo.eflags & MFE_VERTICALFLIP
		mo.momz = height * -1
	else
		mo.momz = height
	end
	/*this nerfs the jumps while underwater or in space so that the player 
	doesn't jump way higher underwater than on dry land*/
	if mo.eflags & MFE_UNDERWATER or mo.eflags & MFE_GOOWATER or 
			P_InSpaceSector(mo)
		if mo.eflags & MFE_VERTICALFLIP
			mo.momz = $ + ($ / 3)
		else
			mo.momz = $ - ($ / 3)
		end
	end
end)

local function JumpState(player)
	if not (player.mo.state == S_PLAY_JUMP or player.mo.state == S_PLAY_FALL)
		player.mo.state = S_PLAY_JUMP
	end
end

/*the iconic tornado move is a global function because crash can also do the
spin while wearing his jetpack/scuba gear*/
rawset(_G, "CrashTornadoSpin", function(player)
	if P_PlayerInPain(player) or player.playerstate == PST_DEAD or 
			player.powers[pw_carry] != CR_NONE
		return
	end
	if player.pressedspin == nil
		player.pressedspin = false
	end
	if player.spintimer == nil
		player.spintimer = 0
	end
	if player.spinpresses == nil
		player.spinpresses = 0
	end
	if player.cooldown == nil
		player.cooldown = 0
	end
	if player.cooldown <= 0
		if input.gameControlDown(GC_CUSTOM1)
			if not player.pressedspin and player.spinpresses <= 10
				S_StartSound(player.mo, sfx_spndsh)
				player.spintimer = 1 * TICRATE
				player.spinpresses = $ + 1
				if P_IsObjectOnGround(player.mo) or player.mo.eflags & 
						MFE_FORCESUPER
					player.cooldown = 2 * TICRATE
					player.spinpresses = 0
				end
				player.pressedspin = true
			end
		else
			player.pressedspin = false
		end
	else
		player.cooldown = $ - 3
	end
	if player.spintimer > 0
		if player.tornado == nil
			player.tornado = 0
		end
		player.tornado = $ + 45
		player.drawangle = FixedAngle(player.tornado * FRACUNIT)
		player.mo.state = S_PLAY_CLING
		player.powers[pw_strong] = STR_ATTACK|STR_SPIKE|STR_WALL|STR_ANIM
		player.spintimer = $ - 2
		player.slideslam = 0
		if player.spinpresses <= 10 and player.spinpresses > 1
			if (player.mo.eflags & MFE_VERTICALFLIP and player.mo.momz > 0) or
					(not (player.mo.eflags & MFE_VERTICALFLIP) and 
					player.mo.momz < 0)
				CrashJumpManager(player.mo, -3 * FRACUNIT)
			end
		end
	else
		if player.mo.state == S_PLAY_CLING
			player.mo.state = S_PLAY_WALK
		end
		if (P_IsObjectOnGround(player.mo) or player.spinpresses <= 10) and not
				(player.mo.eflags & MFE_FORCESUPER)
			player.spinpresses = 0
		end
	end
end)

/*a local function that disables all of crash's normal abilities while in
jetpack mode*/
local function JetpackModeCheck(player)
	if player.mo.eflags & MFE_FORCESUPER
		return true
	else
		return false
	end
end

local function JumpsAndSpins(player)
	if not CrashSkinCheck(player)
		return
	end
	if JetpackModeCheck(player)
		return
	end
	
	if P_PlayerInPain(player) or player.playerstate == PST_DEAD or 
			player.powers[pw_carry] != CR_NONE or player.mo.state == S_PLAY_STUN
		return
	end
	//this resets double-jump
	if player.doublejump == nil
		player.doublejump = false
	end
	if P_IsObjectOnGround(player.mo) or player.mo.state == S_PLAY_RIDE
		player.doublejump = false
	end
	//Do I really need to explain what this is for and why?
	if player.woah == nil
		player.woah = false
	end
	if input.gameControlDown(GC_CUSTOM3) and input.gameControlDown(GC_TOSSFLAG)
			and P_IsObjectOnGround(player.mo)
		player.mo.momx = 0
		player.mo.momy = 0
		player.mo.state = S_PLAY_FLY_TIRED
		player.pflags = $ | PF_FULLSTASIS
		if not player.woah
			S_StartSound(player.mo, sfx_pudpud)
			player.woah = true
		end
	else
		player.woah = false
	end
	/*this handles the different jump sprites displayed to distinguish short
	jumps from full jumps*/
	if player.powers[pw_carry] == CR_NONE
		if player.pflags & PF_THOKKED
			if player.mo.eflags & MFE_VERTICALFLIP
				if player.mo.momz >= -8 * FRACUNIT and player.mo.momz < 0
					player.mo.state = S_PLAY_SPINDASH
				else
					JumpState(player)
				end
			else
				if player.mo.momz <= 8 * FRACUNIT and player.mo.momz > 0
					player.mo.state = S_PLAY_SPINDASH
				else
					JumpState(player)
				end
			end
		elseif player.pflags & PF_STARTJUMP
			if player.mo.eflags & MFE_VERTICALFLIP
				if player.mo.momz >= -5 * FRACUNIT and player.mo.momz < 0
					if not (player.mo.state == S_PLAY_ROLL)
						player.mo.state = S_PLAY_ROLL
					end
				else
					JumpState(player)
				end
			else
				if player.mo.momz <= 5 * FRACUNIT and player.mo.momz > 0
					if not (player.mo.state == S_PLAY_ROLL)
						player.mo.state = S_PLAY_ROLL
					end
				else
					JumpState(player)
				end
			end
		elseif player.pflags & PF_JUMPED
			JumpState(player)
		end
	end
	/*this makes the player perform the iconic spin if they press custom 1 and
	does the death tornado spin glide if the player spams custom 1*/
	if player.slideslam == nil
		player.slideslam = 0
	end
	if player.faceplant == nil
		player.faceplant = 0
	end
	if player.slideslam > 0 or player.faceplant > 0
		return
	end
	CrashTornadoSpin(player)
	//this enables the crash dash if the player is holding down custom 3
	if input.gameControlDown(GC_CUSTOM3) and not (player.powers[pw_sneakers] or
			player.mo.state == S_PLAY_CLIMB)
		player.normalspeed = 36 * FRACUNIT
	elseif not (P_IsObjectOnGround(player.mo) and input.gameControlDown(GC_SPIN))
		player.normalspeed = skins[player.mo.skin].normalspeed
	end
end
addHook("PlayerThink", JumpsAndSpins)

//this makes the player double-jump
local function DoubleJump(player)
	if not CrashSkinCheck(player)
		return
	end
	if JetpackModeCheck(player)
		return true
	end
	
	if not player.doublejump
		player.pflags = $ | PF_THOKKED
		S_StartSound(player.mo, sfx_jump)
		if player.mo.eflags & MFE_UNDERWATER or player.mo.eflags & MFE_GOOWATER
			P_SpawnMobjFromMobj(player.mo, 30 * FRACUNIT, 0, 0, MT_MEDIUMBUBBLE)
			P_SpawnMobjFromMobj(player.mo, -30 * FRACUNIT, 0, 0, MT_MEDIUMBUBBLE)
			P_SpawnMobjFromMobj(player.mo, 0, 30 * FRACUNIT, 0, MT_MEDIUMBUBBLE)
			P_SpawnMobjFromMobj(player.mo, 0, -30 * FRACUNIT, 0, MT_MEDIUMBUBBLE)
		else
			P_SpawnMobjFromMobj(player.mo, 30 * FRACUNIT, 0, 0, MT_ARIDDUST)
			P_SpawnMobjFromMobj(player.mo, -30 * FRACUNIT, 0, 0, MT_ARIDDUST)
			P_SpawnMobjFromMobj(player.mo, 0, 30 * FRACUNIT, 0, MT_ARIDDUST)
			P_SpawnMobjFromMobj(player.mo, 0, -30 * FRACUNIT, 0, MT_ARIDDUST)
		end
		CrashJumpManager(player.mo, 11 * FRACUNIT)
		player.mo.state = S_PLAY_JUMP
		player.doublejump = true
	end
	return true
end
addHook("AbilitySpecial", DoubleJump)

/*this entire table handles crash's abilities on the spin button, since he has
a lot of moves that can be done in said button*/
local function Crash0None(player)
	return
end
local function Crash1Crawl(player)
	player.height = player.spinheight
	player.normalspeed = 5 * FRACUNIT
	if player.mo.momx != 0 and player.mo.momy != 0
		if not (player.mo.state == S_PLAY_CLIMB)
			player.mo.state = S_PLAY_CLIMB
		end
	else
		player.mo.state = S_PLAY_GLIDE_LANDING
	end
end
local function Crash2Slide(player)
	S_StartSound(player.mo, sfx_zoom)
	local slidespeed = player.normalspeed + 10 * FRACUNIT
	if player.mo.eflags & MFE_UNDERWATER or player.mo.eflags & MFE_GOOWATER or 
			P_InSpaceSector(player.mo)
		slidespeed = $ - ($ / 3)
	end
	P_InstaThrust(player.mo, player.mo.angle, slidespeed)
	player.mo.state = S_PLAY_GLIDE
	player.powers[pw_strong] = STR_PUNCH|STR_SPIKE|STR_WALL|STR_ANIM
	player.height = player.spinheight
	player.slidetimer = 1 * TICRATE
end
local function Crash3Slam(player)
	player.mo.momx = 0
	player.mo.momy = 0
	CrashJumpManager(player.mo, 7 * FRACUNIT)
	S_StartSound(player.mo, sfx_cshflp)
	player.mo.state = S_PLAY_MELEE
	player.slamtimer = 1 * TICRATE
end
local CrashCram = {
	[0] = Crash0None,
	[1] = Crash1Crawl,
	[2] = Crash2Slide,
	[3] = Crash3Slam
}
local function CrouchTriggers(player)
	if not CrashSkinCheck(player)
		return
	end
	if JetpackModeCheck(player)
		return true
	end
	
	if player.mo.state == S_PLAY_CLING
		return true
	end
	if player.slideslam == 0
		if P_IsObjectOnGround(player.mo)
			//this makes the player crawl if they're practically still
			local wiggle = 1 * FRACUNIT / 2
			if (player.mo.momx <= wiggle and player.mo.momx >= wiggle * -1) and 
					(player.mo.momy <= wiggle and player.mo.momy >= wiggle * -1)
				player.slideslam = 1
			//this makes the player slide if they were moving
			else
				player.slideslam = 2
			end
		//this makes the player body slam if they were in the air
		elseif (player.pflags & PF_JUMPED or player.mo.state == S_PLAY_FALL) and 
				not (player.pflags & PF_THOKKED) and player.powers[pw_carry] == 
				CR_NONE
			player.slideslam = 3
			CrashCram[player.slideslam](player)
		end
	end
	if player.slideslam != 3
		CrashCram[player.slideslam](player)
	end
	return true
end
addHook("SpinSpecial", CrouchTriggers)

//this makes the player perform a higher jump if they were crawling/sliding
local function CrouchSlideJump(player)
	if not CrashSkinCheck(player)
		return
	end
	if JetpackModeCheck(player)
		return
	end
	
	if player.slideslam == 1 or player.slideslam == 2
		S_StartSound(player.mo, sfx_jump)
		CrashJumpManager(player.mo, 15 * FRACUNIT)
		player.mo.state = S_PLAY_JUMP
		player.pflags = $ | PF_THOKKED
		player.height = skins[player.mo.skin].height
		player.normalspeed = skins[player.mo.skin].normalspeed
		player.slideslam = 0
		return true
	end
	return
end
addHook("JumpSpecial", CrouchSlideJump)

local function SlideSlam(player)
	if not CrashSkinCheck(player)
		return
	end
	if JetpackModeCheck(player)
		return
	end
	
	//this sets crouch jump to true if the player jumps while crawling/sliding
	if player.crouchjump == nil
		player.crouchjump = false
	end
	if input.gameControlDown(GC_JUMP) and (player.slideslam == 1 or 
			player.slideslam == 2)
		player.crouchjump = true
	end
	//this resets crouch jumping
	if P_IsObjectOnGround(player.mo)
		player.crouchjump = false
	end
	//this resets the height changes made by crawling
	if not (P_IsObjectOnGround(player.mo) and input.gameControlDown(GC_SPIN)) 
			and player.slideslam == 1
		player.height = skins[player.mo.skin].height
		player.slideslam = 0
		if player.mo.state == S_PLAY_CLIMB
			player.mo.state = S_PLAY_WALK
		end
	end
	//this cancels everything if the player dies or takes damage or is stunned
	if P_PlayerInPain(player) or player.playerstate == PST_DEAD or 
			player.mo.state == S_PLAY_STUN
		player.crouchjump = false
		player.noslide = false
		player.slamdown = false
		player.faceplant = 0
		player.slideslam = 0
		return
	end
	//this handles what happens while the player is sliding and after
	if player.noslide == nil
		player.noslide = false
	end
	if player.slideslam == 2
		if player.slidetimer > 0
			player.pflags = $ | PF_STASIS
			player.slidetimer = $ - 2
		else
			player.noslide = true
		end
		if player.noslide
			player.mo.state = S_PLAY_WALK
			if input.gameControlDown(GC_SPIN) and P_IsObjectOnGround(player.mo)
				player.slideslam = 1
			else
				player.height = skins[player.mo.skin].height
				player.slideslam = 0
			end
			player.noslide = false
		end
	end
	//this handles the slam itself
	if player.slamdown == nil
		player.slamdown = false
	end
	if player.slideslam == 3
		player.pflags = $ | PF_FULLSTASIS
		if player.slamtimer > 0
			if player.mo.momz == 0
				player.mo.momz = 0
			end
			player.mo.state = S_PLAY_FLY
			player.slamtimer = $ - 4
		elseif not player.slamdown
			CrashJumpManager(player.mo, -50 * FRACUNIT)
			player.slamdown = true
		else
			if player.mo.eflags & MFE_GOOWATER or player.powers[pw_carry] != 
					CR_NONE or (player.mo.momz > 0 and not (player.mo.eflags & 
					MFE_VERTICALFLIP)) or (player.mo.momz < 0 and 
					player.mo.eflags & MFE_VERTICALFLIP)
				if player.powers[pw_carry] != CR_NONE
					player.mo.state = S_PLAY_WALK
				else
					player.mo.state = S_PLAY_JUMP
				end
				player.slamdown = false
				player.slideslam = 0
				return
			elseif not P_IsObjectOnGround(player.mo)
				player.mo.state = S_PLAY_MELEE
				player.powers[pw_strong] = STR_HEAVY|STR_FLOOR|STR_SPRING|
						STR_STOMP|STR_ANIM
			else
				S_StartSound(player.mo, sfx_pstop)
				local px = player.mo.x
				local py = player.mo.y
				local br = 75 * FRACUNIT
				local mo = player.mo
				P_Earthquake(player.mo, player.mo, 90 * FRACUNIT)
				searchBlockmap("objects", function(mo, found)
					if found and found.valid and found.health and 
							P_CheckSight(mo, found) and (found.z < mo.z + 
							mo.height / 2 and found.z > mo.z - mo.height / 2)
						P_DamageMobj(found, mo, mo, 1, 0)
					end
				end, mo, px-br, px+br, py-br, py+br)
				player.faceplant = 1 * TICRATE
				player.slamdown = false
				player.slideslam = 0
			end
		end
	end
	if player.faceplant > 0
		player.mo.momx = 0
		player.mo.momy = 0
		player.pflags = $ | PF_FULLSTASIS
		player.mo.state = S_PLAY_MELEE_LANDING
		player.faceplant = $ - 3
	elseif player.mo.state == S_PLAY_MELEE_LANDING
		player.mo.state = S_PLAY_WALK
	end
end
addHook("PlayerThink", SlideSlam)