/*Behold... baby's second LUA spaghetti code! Fear its overcomplicated recipe!
What's that? Where's the first? Check back in 2025, maybe
~~~~~
this entire lua script is dedicated to crash's health system as well as aku 
aku's object data and all the item/sound reskins*/

freeslot("MT_AKUAKU", "S_AKU_STND","SPR_AKUS", "SPR_CRRG", "SPR_CRPT", "SPR_CRMG", 
		"SPR_CRFC", "SPR_CRNK", "SPR_CRWD", "SPR_CREL", "SPR_CRSP", "SPR_CRIN", 
		"SPR_CRLF", "SPR_CRNO", "SPR_CRTP", "SPR_CRRD", "SPR_CRGT", "SPR_CRRC", 
		"SPR_CRFR", "SPR_CRBB", "SPR_CRTH", "SPR_CSPT", "SPR_CSMG", "SPR_CSFC", 
		"SPR_CSNK", "SPR_CSWD", "SPR_CSEL", "SPR_CSSP", "SPR_CSIN", "SPR_CSNO", 
		"SPR_CSGT", "SPR_CSFR", "SPR_CSBB", "SPR_CSTH", "SPR_CSBL", "SPR_RDRG", 
		"SPR_BLRG", "SPR_CRCK", "SPR_CRCH", "sfx_cshflp", "sfx_cshlfe", 
		"sfx_akuded", "sfx_akuspn", "sfx_boxbrk", "sfx_swchht", "sfx_ckptht", 
		"sfx_ntrbnc", "sfx_cshpew", "sfx_cshdth", "sfx_ashcsh", "sfx_cshxry", 
		"sfx_cshngl", "sfx_crdrwn", "sfx_cshfal")
states[S_AKU_STND] = {
	sprite = SPR_AKUS,
	frame = A,
	tics = 1,
	nextstate = S_AKU_STND,
	action = A_Custom3DRotate
}
mobjinfo[MT_AKUAKU] = {
	spawnstate = S_AKU_STND,
	spawnhealth = 1,
	seestate = S_AKU_STND,
	speed = 25,
	radius = 10*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_FLOAT|MF_NOCLIP
}
function A_ExtraLife(actor, var1, var2)
	if actor.target.skin == "bandicoot" and not ultimate
		P_GiveCoopLives(actor.target.player, 1, false)
		S_StartSound(actor.target, sfx_cshlfe, actor.target.player)
	else
		super(actor, var1, var2)
	end
end
local function Aku0Dead(player)
	if player.akuaku and player.akuaku.valid
		P_KillMobj(player.akuaku)
	end
end
local function Aku1Spawn(player)
	if player.akuaku == nil or not player.akuaku.valid
		player.akuaku = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_AKUAKU)
		player.akuaku.target = player.mo
		player.akuaku.shadowscale = 2 * FRACUNIT / 3
	elseif player.akulevel < 2
		player.akuaku.colorized = false
	end
	if player.mo.eflags & MFE_VERTICALFLIP
		player.akuaku.eflags = $ | MFE_VERTICALFLIP
	else
		player.akuaku.eflags = $ & ~MFE_VERTICALFLIP
	end
end
local function Aku2Upgrade(player)
	Aku1Spawn(player)
	if not player.akuaku.colorized
		player.akuaku.colorized = true
		player.akuaku.color = SKINCOLOR_ORANGE
	end
end
function A_Invincibility(actor, var1, var2)
	super(actor, var1, var2)
	if actor.target.skin == "bandicoot"
		P_PlayJingleMusic(actor.target.player, "CSHINV", 0, false, JT_INV)
	end
end
local function Aku3Invincible(player)
	Aku2Upgrade(player)
	if not player.powers[pw_invulnerability]
		A_Invincibility(player.akuaku)
	end
	local akuakuheight = player.mo.z
	if player.mo.eflags & MFE_VERTICALFLIP
		akuakuheight = player.mo.z - player.height - 10 * FRACUNIT
	else
		akuakuheight = player.mo.z + player.height + 10 * FRACUNIT
	end
	player.akuaku.invin = true
	P_MoveOrigin(player.akuaku, player.mo.x, player.mo.y, akuakuheight)
	player.akuaku.angle = player.mo.angle
end
local AkuLevels = {
	[0] = Aku0Dead,
	[1] = Aku1Spawn,
	[2] = Aku2Upgrade,
	[3] = Aku3Invincible
}
/*this determines what happens when the player gets a shield or invincibility
which effects aku aku*/
local function AkuAkuLevel(player)
	if not CrashSkinCheck(player) or player.powers[pw_carry] == CR_NIGHTSMODE
		if player.akuaku and player.akuaku.valid
			if player.akuaku.invin
				player.powers[pw_invulnerability] = 0
			end
			P_KillMobj(player.akuaku)
		end
		return
	end
	
	if player.akulevel == nil
		player.akulevel = 0
	end
	if player.powers[pw_shield]
		if not (player.powers[pw_invulnerability] or player.powers[pw_shield] ==
				SH_PINK)
			player.akulevel = $ + 1
			if player.akulevel < 3
				S_StartSound(player.mo, sfx_akuspn)
			end
		end
		player.powers[pw_shield] = SH_NONE
	end
	if player.powers[pw_invulnerability]
		if player.akulevel < 3
			player.akulevel = 3
		end
	else
		if player.akuaku and player.akuaku.valid
			if player.akuaku.invin
				player.akulevel = 1
				S_StartSound(player.mo, sfx_akuded)
				player.akuaku.invin = false
			end
		end
	end
	AkuLevels[player.akulevel](player)
end
addHook("PlayerThink", AkuAkuLevel)

/*modifying the function to define the values for aku aku's rotation around the
player*/
function A_Custom3DRotate(actor, var1, var2)
	//var1(placement) = (vertical offset << 16) + radius
	//var2(rotation) = (horizontal speed << 16) + vertical speed
	if actor.type == MT_AKUAKU
		if actor.invin
			A_ForceStop(actor, 0)
		else
			if actor.eflags & MFE_VERTICALFLIP
				var1 = (-25 << 16) + 40
			else
				var1 = (25 << 16) + 40
			end
			var2 = (60 << 16) + 0
		end
	end
	super(actor, var1, var2)
end

//this determines what happens if the player gets hit
local function HealthPoints(target, inflictor, source, damage, damagetype)
	if target.skin != "bandicoot" or target.player.powers[pw_carry] ==
			CR_NIGHTSMODE
		return
	end
	
	if target.player.akulevel == 0
		P_KillMobj(target, inflictor, source, damagetype)
	else
		target.player.akulevel = $ - 1
		S_StartSound(target, sfx_akuded)
		P_DoPlayerPain(target.player, source, inflictor)
	end
	return true
end
addHook("MobjDamage", HealthPoints, MT_PLAYER)

//this transforms all the monitors in the game into crates
states[S_RING_BOX] = {
	sprite = SPR_CRRG,
	frame = A,
	tics = 1,
	nextstate = S_RING_BOX
}
states[S_PITY_BOX] = {
	sprite = SPR_CRPT,
	frame = A,
	tics = 1,
	nextstate = S_PITY_BOX
}
states[S_ATTRACT_BOX] = {
	sprite = SPR_CRMG,
	frame = A,
	tics = 1,
	nextstate = S_ATTRACT_BOX
}
states[S_FORCE_BOX] = {
	sprite = SPR_CRFC,
	frame = A,
	tics = 1,
	nextstate = S_FORCE_BOX
}
states[S_ARMAGEDDON_BOX] = {
	sprite = SPR_CRNK,
	frame = A,
	tics = 1,
	nextstate = S_ARMAGEDDON_BOX
}
states[S_WHIRLWIND_BOX] = {
	sprite = SPR_CRWD,
	frame = A,
	tics = 1,
	nextstate = S_WHIRLWIND_BOX
}
states[S_ELEMENTAL_BOX] = {
	sprite = SPR_CREL,
	frame = A,
	tics = 1,
	nextstate = S_ELEMENTAL_BOX
}
states[S_SNEAKERS_BOX] = {
	sprite = SPR_CRSP,
	frame = A,
	tics = 1,
	nextstate = S_SNEAKERS_BOX
}
states[S_INVULN_BOX] = {
	sprite = SPR_CRIN,
	frame = A,
	tics = 1,
	nextstate = S_INVULN_BOX
}
function A_1upThinker(actor, var1, var2)
	super(actor, var1, var2)
	actor.sprite = SPR_CRLF
end
states[S_1UP_BOX] = {
	sprite = SPR_CRLF,
	frame = A,
	tics = 1,
	nextstate = S_1UP_BOX,
	action = A_1upThinker
}
states[S_EGGMAN_BOX] = {
	sprite = SPR_CRNO,
	frame = A,
	tics = 1,
	nextstate = S_EGGMAN_BOX
}
states[S_MIXUP_BOX] = {
	sprite = SPR_CRTP,
	frame = A,
	tics = 1,
	nextstate = S_MIXUP_BOX
}
states[S_MYSTERY_BOX] = {
	sprite = SPR_CRRD,
	frame = A,
	tics = 1,
	nextstate = S_MYSTERY_BOX
}
states[S_GRAVITY_BOX] = {
	sprite = SPR_CRGT,
	frame = A,
	tics = 1,
	nextstate = S_GRAVITY_BOX
}
states[S_RECYCLER_BOX] = {
	sprite = SPR_CRRC,
	frame = A,
	tics = 1,
	nextstate = S_RECYCLER_BOX
}
states[S_FLAMEAURA_BOX] = {
	sprite = SPR_CRFR,
	frame = A,
	tics = 1,
	nextstate = S_FLAMEAURA_BOX
}
states[S_BUBBLEWRAP_BOX] = {
	sprite = SPR_CRBB,
	frame = A,
	tics = 1,
	nextstate = S_BUBBLEWRAP_BOX
}
states[S_THUNDERCOIN_BOX] = {
	sprite = SPR_CRTH,
	frame = A,
	tics = 1,
	nextstate = S_THUNDERCOIN_BOX
}
function A_MonitorPop(actor, var1, var2)
	super(actor, var1, var2)
	S_StartSound(actor, sfx_boxbrk)
end
states[S_BOX_POP1] = {
	sprite = SPR_NULL,
	frame = A,
	tics = 4,
	nextstate = S_BOX_POP2,
	action = A_MonitorPop
}
states[S_BOX_POP2] = {
	sprite = SPR_NULL,
	frame = A,
	tics = -1,
	nextstate = S_NULL
}
states[S_PITY_GOLDBOX] = {
	sprite = SPR_CSPT,
	frame = A,
	tics = 1,
	nextstate = S_PITY_GOLDBOX
}
states[S_ATTRACT_GOLDBOX] = {
	sprite = SPR_CSMG,
	frame = A,
	tics = 1,
	nextstate = S_ATTRACT_GOLDBOX
}
states[S_FORCE_GOLDBOX] = {
	sprite = SPR_CSFC,
	frame = A,
	tics = 1,
	nextstate = S_FORCE_GOLDBOX
}
states[S_ARMAGEDDON_GOLDBOX] = {
	sprite = SPR_CSNK,
	frame = A,
	tics = 1,
	nextstate = S_ARMAGEDDON_GOLDBOX
}
states[S_WHIRLWIND_GOLDBOX] = {
	sprite = SPR_CSWD,
	frame = A,
	tics = 1,
	nextstate = S_WHIRLWIND_GOLDBOX
}
states[S_ELEMENTAL_GOLDBOX] = {
	sprite = SPR_CSEL,
	frame = A,
	tics = 1,
	nextstate = S_ELEMENTAL_GOLDBOX
}
states[S_SNEAKERS_GOLDBOX] = {
	sprite = SPR_CSSP,
	frame = A,
	tics = 1,
	nextstate = S_SNEAKERS_GOLDBOX
}
states[S_INVULN_GOLDBOX] = {
	sprite = SPR_CSIN,
	frame = A,
	tics = 1,
	nextstate = S_INVULN_GOLDBOX
}
states[S_EGGMAN_GOLDBOX] = {
	sprite = SPR_CSNO,
	frame = A,
	tics = 1,
	nextstate = S_EGGMAN_GOLDBOX
}
states[S_GRAVITY_GOLDBOX] = {
	sprite = SPR_CSGT,
	frame = A,
	tics = 1,
	nextstate = S_GRAVITY_GOLDBOX
}
states[S_FLAMEAURA_GOLDBOX] = {
	sprite = SPR_CSFR,
	frame = A,
	tics = 1,
	nextstate = S_FLAMEAURA_GOLDBOX
}
states[S_BUBBLEWRAP_GOLDBOX] = {
	sprite = SPR_CSBB,
	frame = A,
	tics = 1,
	nextstate = S_BUBBLEWRAP_GOLDBOX
}
states[S_THUNDERCOIN_GOLDBOX] = {
	sprite = SPR_CSTH,
	frame = A,
	tics = 1,
	nextstate = S_THUNDERCOIN_GOLDBOX
}
function A_GoldMonitorPop(actor, var1, var2)
	super(actor, var1, var2)
	S_StartSound(actor, sfx_swchht)
end
states[S_GOLDBOX_OFF1] = {
	sprite = SPR_CSBL,
	frame = A,
	tics = 89,
	nextstate = S_GOLDBOX_OFF2,
	action = A_GoldMonitorPop
}
states[S_RING_REDBOX1] = {
	sprite = SPR_RDRG,
	frame = A,
	tics = 1,
	nextstate = S_RING_REDBOX1
}
states[S_REDBOX_POP1] = {
	sprite = SPR_RDRG,
	frame = A,
	tics = 4,
	nextstate = S_REDBOX_POP2,
	action = A_MonitorPop
}
states[S_REDBOX_POP2] = {
	sprite = SPR_NULL,
	frame = A,
	tics = -1,
	nextstate = S_NULL
}
states[S_RING_BLUEBOX1] = {
	sprite = SPR_BLRG,
	frame = A,
	tics = 1,
	nextstate = S_RING_BLUEBOX1
}
states[S_BLUEBOX_POP1] = {
	sprite = SPR_RDRG,
	frame = A,
	tics = 4,
	nextstate = S_BLUEBOX_POP2,
	action = A_MonitorPop
}
states[S_BLUEBOX_POP2] = {
	sprite = SPR_NULL,
	frame = A,
	tics = -1,
	nextstate = S_NULL
}
//this turns the starposts (checkpoints) into checkpoint crates
states[S_STARPOST_IDLE] = {
	sprite = SPR_CRCK,
	frame = A,
	tics = -1,
	nextstate = S_NULL
}
states[S_STARPOST_FLASH] = {
	sprite = SPR_CRCH,
	frame = FF_FLOORSPRITE|A,
	tics = -1,
	nextstate = S_NULL
}
mobjinfo[MT_STARPOST] = {
	doomednum = 502,
	spawnstate = S_STARPOST_IDLE,
	spawnhealth = 1,
	seestate = S_STARPOST_FLASH,
	painstate = S_STARPOST_SPIN,
	painsound = sfx_ckptht,
	reactiontime = 8,
	speed = 8,
	radius = 64*FRACUNIT,
	height = 80*FRACUNIT,
	mass = 4,
	flags = MF_SPECIAL
}

//this makes the nitro bounce up randomly for added deadliness
local function NitroBounce(mo)
	if mo.valid
		local willhop = P_RandomKey(100)
		if willhop == 5
			CrashJumpManager(mo, 5 * FRACUNIT)
			S_StartSound(mo, sfx_ntrbnc)
		end
	end
end
addHook("MobjThinker", NitroBounce, MT_EGGMAN_BOX)

//this handles what happens to the nitro crates when touched
local function NitroNoTouch(thing, tmthing)
	if tmthing.type == MT_PLAYER
		if tmthing.z >= thing.z - thing.height and tmthing.z <= thing.z + 
				thing.height
			P_KillMobj(thing)
		end
	end
end
addHook("MobjCollide", NitroNoTouch, MT_EGGMAN_BOX)

//this handles what happens if a nitro crate gets destroyed
local function MonitorBreak(target, inflictor, source, damagetype)
	local nitroexplode = P_SpawnMobjFromMobj(target, 0, 0, 0, 
			MT_TNTBARREL)
	nitroexplode.colorized = true
	nitroexplode.color = SKINCOLOR_GREEN
	P_KillMobj(nitroexplode)
end
addHook("MobjDeath", MonitorBreak, MT_EGGMAN_BOX)